<template>
  <div>
    <div class="d-flex justify-space-between">
      <div style="width: 100px;">
        <v-select
          v-model="perPage"
          :label="$t('totalVisible')"
          :items="listPerPage"
          @change="getPedidos"
          dense
        />
      </div>
      <div class="d-flex justify-end">
        <v-btn
          v-if="!esPedido"
          class="mt-2 mr-4"
          color="success"
          rounded
          small
          @click="nuevoPedido"
          :disabled="loading"
        >
          <v-icon>mdi-table-plus</v-icon>
          {{ $t('nuevoPedido') }}
        </v-btn>
        <v-btn
          class="mt-2 mr-4"
          color="primary"
          rounded
          small
          @click="refreshTable"
          :disabled="loading"
        >
          <v-icon>mdi-refresh</v-icon>
          {{ $t('actualizar') }}
        </v-btn>
        <v-pagination
          v-model="currentPage"
          :disabled="loading"
          :length="lastPage"
          :total-visible="8"
        />
      </div>
    </div>
    <v-data-table
      v-model="selected"
      :headers="headers"
      :items="pedidosData"
      item-key="id"
      class="elevation-1"
      disable-pagination
      hide-default-footer
      dense
      :loading="loading"
      :single-expand="singleExpand"
      show-expand
    >
      <template  v-slot:item.actions="{ item }">
        <v-menu
          v-if="!esPedido"
          bottom
          left
        >
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              icon
              v-bind="attrs"
              v-on="on"
            >
              <v-icon>mdi-dots-vertical</v-icon>
            </v-btn>
          </template>
          <v-list dense>
            <v-list-item-group>
              <v-list-item v-if="permiso === 'ADMIN' || permiso === 'JEFATURA'"  @click="cambiarEstado(item, 'APROBADO')">
                <v-list-item-icon>
                  <v-icon>mdi-check-outline</v-icon>
                </v-list-item-icon>
                <v-list-item-content>
                  <v-list-item-title>{{ $t('aprobar') }}</v-list-item-title>
                </v-list-item-content>
              </v-list-item>
              <v-list-item v-if="permiso === 'ADMIN' || permiso === 'JEFATURA'"  @click="cambiarEstado(item, 'RECHAZADO')">
                <v-list-item-icon>
                  <v-icon>mdi-close-outline</v-icon>
                </v-list-item-icon>
                <v-list-item-content>
                  <v-list-item-title>{{ $t('rechazar') }}</v-list-item-title>
                </v-list-item-content>
              </v-list-item>
              <v-list-item v-if="permiso === 'ADMIN' || permiso === 'ALMACEN'"  @click="entregar(item)">
                <v-list-item-icon>
                  <v-icon>mdi-cart-arrow-up</v-icon>
                </v-list-item-icon>
                <v-list-item-content>
                  <v-list-item-title>{{ $t('entregar') }}</v-list-item-title>
                </v-list-item-content>
              </v-list-item>
              <!-- <v-list-item>
                <v-list-item-icon>
                  <v-icon>mdi-printer</v-icon>
                </v-list-item-icon>
                <v-list-item-content>
                  <v-list-item-title @click="imprimir2">{{ $t('imprimir') }}</v-list-item-title>
                </v-list-item-content>
              </v-list-item> -->
            </v-list-item-group>
          </v-list>
        </v-menu>
        <v-btn
          v-if="esPedido"
          small
          icon
          @click="agregarPedido(item)"
        >
          <v-icon>mdi-cart-plus</v-icon>
        </v-btn>
      </template>
      <template v-slot:item.estado="{ item }">
        <v-chip
          class="ma-2"
          :color="colorEstado(item.estado)"
        >
          {{ item.estado }}
        </v-chip>
      </template>
      <template v-slot:expanded-item="{ headers, item }">
        <td :colspan="headers.length">
          <SubDetallePedido :items="item.detalle_pedido"/>
        </td>
      </template>
    </v-data-table>
    <FramePdf
      :fileUrl="filePdf"
      :dialog="dialog"
      @onCloseDialog="closeDialog"
    />
  </div>
</template>

<script>
import PedidoServicio from '@/store/services/PedidoServicio'
import RecepcionServicio from '@/store/services/RecepcionServicio'
import SubDetallePedido from './SubDetallePedido'
import FramePdf from '@/components/app/framePdf'
export default {
  name: "Pedidos",
  components: {
    SubDetallePedido,
    FramePdf
  },
  props:{
    esPedido: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  data() {
    return {
      expanded: [],
      singleExpand: false,
      listPerPage: [5, 10, 50, this.$t('todo')],
      perPage: 50,
      lastPage: 0,
      total: 0,
      currentPage: 1,
      pedidosData: [],
      selected: [],
      loading: false,
      filePdf: null,
      dialog: false,
      form: {
        estado: ''
      },
      permiso: null,
      tipo: ''
    }
  },
  methods: {
    verifyType(value) {
      return typeof value;
    },
    async getPedidos() {
      this.loading = true;
      let params = {
        page: this.currentPage,
        order_by: 'created_at',
        order_direction: 'DESC',
        per_page:
          this.verifyType(this.perPage) === 'string'
            ? this.total
            : this.perPage,
      }
      if (this.esPedido) {
        let search = { search: 'tipo:' + this.tipo + ';estado:ENTREGADO !=' }
        params = { ...params, ...search}
      }
      try {
        let response = await PedidoServicio.index(params)
        this.pedidosData = response.data.data;
        this.currentPage = response.data.current_page;
        this.lastPage = response.data.last_page;
        this.total = response.data.total;
        this.loading = false;
      } catch (error) {
        this.loading = false;
        if (error.response.status !== 401) {
          console.log(error.response.message)
        }
      }
    },
    refreshTable() {
      this.resetCurrentPage();
    },
    resetCurrentPage() {
      if (this.currentPage === 1) this.getPedidos();
      else this.currentPage = 1;
    },
    nuevoPedido() {
      this.$emit('onNuevoPedido');
    },
    editarPedido(value) {
      this.$emit('onEditarPedido', value)
    },
    agregarPedido(value) {
      this.$emit('onAgregarPedido', value)
    },
    async imprimir() {
      try {
        let response = await PedidoServicio.reporte('pdf', {
          responseType: 'blob',
          Accept: 'application/pdf',
        })
        const url = window.URL.createObjectURL(new Blob([response.data], {type: 'application/pdf'}));
        this.filePdf = url
        this.dialog = true
        const link = document.createElement('a');
        console.log(link);
        // link.href = url;
        // link.setAttribute('download', 'staffs.pdf'); //or any other extension
        // document.body.appendChild(link);
        // link.click();
        // console.log(pdf)
      } catch (error) {
        console.log(error)
      }
    },
    async imprimir2() {
      try {
        let response = await RecepcionServicio.imprimir('imprimir/pre', {
          responseType: 'blob',
          Accept: 'application/pdf',
        })
        const url = window.URL.createObjectURL(new Blob([response.data], {type: 'application/pdf'}));
        this.filePdf = url
        this.dialog = true
      } catch (error) {
        console.log(error)
      }
    },
    closeDialog() {
      this.dialog = false
      this.filePdf = null
    },
    async cambiarEstado(value, nuevoEstado) {
      this.form.estado = nuevoEstado
      this.loading = true
      try {
        let response = await PedidoServicio.cambiarEstado(value.id, this.form)
        this.refreshTable()
        this.loading = false
        console.log(response)
      } catch (error) {
        this.loading = false
        console.log(error)
      }
    },
    colorEstado(estado) {
      if (estado === 'APROBADO') return 'success'
      else if (estado === 'RECHAZADO') return 'error'
      else if (estado === 'ENTREGADO') return 'info'
      else if (estado === 'COMPRADO') return 'accent'
      else return 'warning'
    },
    entregar(value) {
      if (value.estado === 'ENTREGADO') {
        alert('El pedido ya fue entregado')
      } else if (value.estado === 'RECHAZADO') {
        alert('El pedido fue rechazado')
      } else if (value.estado !== 'APROBADO') {
        alert('El pedido no fue aprobado')
      } else {
        this.$router.push({name: 'entregas', params: {id: value.id}})
      }
    }
  },
  computed: {
    headers() {
      return [
        {
          value: 'actions',
          sortable: false,
        },
        {
          text: this.$t('codigo'),
          value: 'id',
          sortable: false,
          align: 'center'
        },
        {
          text: this.$t('usuario'),
          value: 'usuario.name',
          sortable: false,
        },
        {
          text: this.$t('area'),
          value: 'usuario.area',
          sortable: false,
        },
        {
          text: this.$t('tipo'),
          value: 'tipo',
          sortable: false,
        },
        {
          text: this.$t('autorizador'),
          value: 'autorizador.name',
          sortable: false,
        },
        {
          text: this.$t('fechaDeAutorizacion'),
          value: 'fecha_autorizacion',
          sortable: false,
        },
        {
          text: this.$t('estado'),
          value: 'estado',
          sortable: false,
        },
      ];
    },
  },
  watch: {
    currentPage() {
      this.getPedidos();
    },
  },
  created() {
    if (this.esPedido) {
      this.tipo = 'COMPRA'
    }
    let user = localStorage.getItem('user')
    this.permiso = user
    this.getPedidos()
  }
}
</script>

<style>

</style>
